//+------------------------------------------------------------------+
//|                                                       MA rsi.mq4 |
//|                                      Copyright  2006, Eli hayun |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Eli hayun"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
//---- input parameters
extern int       timeFrame=0;
extern int       maPeriod=50;
extern int       maMethod=MODE_EMA;
extern int       maPrice=PRICE_CLOSE;
extern int       rsiPeriod=40;
extern int       rsiLevel=50;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   timeFrame=MathMax(timeFrame,Period());
//----

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=MathMax(Bars-counted_bars,3-timeFrame/Period());
//---- main loop
   for(int i=limit; i>=0; i--)
     {
         int y = iBarShift(NULL,timeFrame,Time[i]);
         double ma = iMA(NULL,timeFrame,maPeriod, 0, maMethod, maPrice, y);
         double rsi= iRSI(NULL,timeFrame, rsiPeriod, maPrice, y);
         if (rsi >= rsiLevel)
            ExtMapBuffer1[i] = ma;
         else
            ExtMapBuffer2[i] = ma;
     }
   return(0);
  }
//+------------------------------------------------------------------+